#include <stdio.h>
#include "../../INCLUDE/const.h"
#include "../../INCLUDE/struct.h"
#include "../../INCLUDE/var_ext.h"
#include "../../INCLUDE/macros.h"

#ifdef REACHABILITY
extern void push_token();
extern void optimized_get_pointer_info();
extern void insert_token();
extern Token_p pop_token();

#ifdef SYMBOLIC
extern Canonic_p sfl_h;
extern Cart_p token;
extern Cart_p dyn;
#endif

#define MAX_DIGIT 11

char cache_string[MAX_CACHE];
#ifdef SYMBOLIC
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
static int get_ordinary_tokens(tk_p,pl)
 Token_p tk_p;
 int pl;
 {/* Init get_ordinary_tokens */
  int ret_value = 1;
  int ii = GET_PLACE_COMPONENTS(pl);
  int cl,ss,ds;  

  for( ; ii ; ii--)
   {/* Per ogni componente del dominio del posto */
    cl = GET_COLOR_COMPONENT(ii - 1,pl);
    if(IS_UNORDERED(cl) || (IS_ORDERED(cl) && GET_STATIC_SUBCLASS(cl) == 1))    
     {/* Classe non ordinata */
      ds = tk_p->id[ii - 1];
      ss = get_static_subclass(cl,ds);
      ret_value *= GET_CARD(cl,ss,ds);
     }/* Classe non ordinata */
   }/* Per ogni componente del dominio del posto */
  return(ret_value);
 }/* End get_ordinary_tokens */
#endif
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void string_to_marking(marking_as_string)
 char *marking_as_string;
 {/* Init string_to_marking */

  register int pl,k;
  int comp;
  char *str = marking_as_string;
  int new_molt = 0;
  int element_id;
#ifdef SYMBOLIC
  int ordinary_tokens;
  int cl,sb,ds;
  int nds,crd;
  struct TOKEN_INFO info;
  TokInfo_p info_ptr = &info;
#endif
  Token_p tk_p = NULL;
  Token_p ntk_p = NULL;
  Token_p last_ptr = NULL;

  for (pl = 0; pl < npl; pl++)
   {/* Per ogni posto */
    if(!IS_NEUTRAL(pl))
     {
      for(tk_p = net_mark[pl].marking; tk_p != NULL;tk_p = ntk_p)
       {
	ntk_p = tk_p->next;
        push_token(tk_p,pl);
       }
      net_mark[pl].marking = NULL;
     }
    net_mark[pl].total = 0;
    net_mark[pl].different = 0;
#ifdef SYMBOLIC
    net_mark[pl].ordinary = 0;
#endif
   }/* Per ogni posto */
#ifdef SYMBOLIC
  while(*str++ != '&');
  for(cl = 0; cl < ncl; cl++)
   {/* Per ogni classe di colore */
    if(IS_UNORDERED(cl) || (IS_ORDERED(cl) && GET_STATIC_SUBCLASS(cl) == 1))
     {/* Classe non ordinata */
      RESET_NUM_CL(cl);
      for(sb = 0; sb < GET_STATIC_SUBCLASS(cl); sb++)
       {/* Per ogni sottoclasse statica */
        RESET_NUM_SS(cl,sb);
        sscanf(str,"%d",&nds);
        while(*str++ != ' ');
        for(ds = 0; ds < nds; ds++)
         {/* Per ogni sottoclasse dinamica */
	  INCREASE_NUM_SS(cl,sb);
	  INCREASE_NUM_CL(cl);
          sscanf(str,"%d",&crd);
	  SET_CARD(cl,sb,ds,crd);
	  while(*str++ != ' ');
         }/* Per ogni sottoclasse dinamica */
       }/* Per ogni sottoclasse statica */
     }/* Classe non ordinata */
   }/* Per ogni classe di colore */
  str = marking_as_string;
#endif
  for (pl = 0; pl < npl; pl++)
   {/* Per ogni posto */
    last_ptr = NULL;
    while(*str++ != '*');
    comp = tabp[pl].comp_num;
    while (*str != '*')
     {/* Informazioni su di un posto */
      sscanf(str,"%d",&new_molt);
      if(IS_NEUTRAL(pl))
       {/* Posto neutro */
	SET_TOKEN_MOLTEPLICITY(new_molt,net_mark[pl].marking);
	net_mark[pl].total = new_molt;
	net_mark[pl].different = 1;
#ifdef SYMBOLIC
	net_mark[pl].ordinary = 1;
#endif
	while(*str != '*')
	 str++;
       }/* Posto neutro */
      else
       {/* Posto colorato */

        tk_p = pop_token(pl);
	tk_p->molt = new_molt;
	while(*str++ != ' ');
	for (k = 0; k < comp - 1; k++)
	 {
	  sscanf(str,"%d",&element_id);
	  tk_p->id[k] = element_id;
	  while(*str++ != ' ');
	 }
	sscanf(str,"%d",&element_id);
	tk_p->id[comp-1] = element_id;
	while(*str++ != ' ');
#ifdef COLOURED
	net_mark[pl].total += new_molt;
#endif
	(net_mark[pl].different)++;
#ifdef COLOURED
	if(net_mark[pl].marking == NULL)
	 {/* Inserimento in testa */
	  tk_p->next = net_mark[pl].marking;
	  net_mark[pl].marking = tk_p;
	 }/* Inserimento in testa */
	else
	 {/* Inserimento al fondo */
	  last_ptr->next = tk_p;
	  tk_p->next = NULL;
	 }/* Inserimento al fondo */
	last_ptr = tk_p;
#endif
#ifdef SYMBOLIC
	ordinary_tokens = get_ordinary_tokens(tk_p,pl);
	net_mark[pl].total += (tk_p->molt * ordinary_tokens);
	net_mark[pl].ordinary += ordinary_tokens;
        optimized_get_pointer_info(tk_p->id,pl,info_ptr);
	insert_token(info_ptr,tk_p,pl);
#endif
       }/* Posto colorato */
     }/* Informazioni su di un posto */
   }/* Per ogni posto */
 }/* End string_to_marking */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
int marking_to_string()
 {/* Init marking_to_string */
  register int i,k,tk;
#ifdef SYMBOLIC
  register int d;
#endif
  int c_count;
  int shift;
  char *str = cache_string;
  char buffer[MAX_DIGIT];
#ifdef SYMBOLIC
  int molt,cl,offset;
#endif

  c_count = 0;
  for(i = 0 ; i < npl ; i++)
   {/* Per ogni posto */
    if( c_count + 1 > MAX_CACHE )
     goto file_string;
    sprintf(str,"*");
    c_count++;
    str++;
    if(IS_NEUTRAL(i))
     {
      sprintf(buffer,"%d",net_mark[i].total);
      shift = strlen(buffer);
      if( c_count + shift > MAX_CACHE )
       goto file_string;
      sprintf(str,"%d",net_mark[i].total);
      c_count += shift;
      str += shift;
     }
    else
     if(IS_FULL(i))
      {/* Posto pieno colorato */
#ifdef COLOURED
       Token_p tk_p;

       for(tk_p = net_mark[i].marking; tk_p != NULL; tk_p = NEXT_TOKEN(tk_p))
        {/* Per ogni token della marcatura */
         sprintf(buffer,"%d ",tk_p->molt);
         shift = strlen(buffer);
         if( c_count + shift > MAX_CACHE )
          goto file_string;
	 sprintf(str,"%d ",tk_p->molt);
         c_count += shift;
         str += shift;
 	 for (k = 0 ; k < tabp[i].comp_num - 1; k++)
	  {
           tk = tk_p->id[k];
           sprintf(buffer,"%d ",tk);
           shift = strlen(buffer);
           if( c_count + shift > MAX_CACHE )
            goto file_string;
 	   sprintf(str,"%d ",tk);
           c_count += shift;
           str += shift;
	  }
         tk = tk_p->id[k];
         sprintf(buffer,"%d ",tk);
         shift = strlen(buffer);
         if( c_count + shift > MAX_CACHE )
          goto file_string;
 	 sprintf(str,"%d ",tk);
         c_count += shift;
         str += shift;
        }/* Per ogni token della marcatura */
#endif
#ifdef SYMBOLIC
     for (k = 0 ; k < tabp[i].comp_num ; k++)
      {
       dyn->low[k] = token->low[k] = token->up[k] = 0;
       cl = tabp[i].dominio[k];
       if(IS_UNORDERED(cl) || (IS_ORDERED(cl) && GET_STATIC_SUBCLASS(cl) == 1))
        dyn->up[k] = GET_NUM_CL(cl) - 1;
       else
        dyn->up[k] = tabc[cl].card - 1;
      }
     do
      {
       for (k = 0 ; k < tabp[i].comp_num ; k++)
	{
	 cl = tabp[i].dominio[k];
	 if(IS_UNORDERED(cl) || (IS_ORDERED(cl) && GET_STATIC_SUBCLASS(cl) == 1))
	  token->mark[k][0] = sfl_h->min[cl][dyn->low[k]];
	 else
	  token->mark[k][0] = dyn->low[k];
	}
       molt = get_marking_of(token,i,TRUE);
       if(molt)
	{
         sprintf(buffer,"%d ",molt);
         shift = strlen(buffer);
         if( c_count + shift > MAX_CACHE )
          goto file_string;
	 sprintf(str,"%d ",molt);
         c_count += shift;
         str += shift;
 	 for (k = 0 ; k < tabp[i].comp_num - 1; k++)
	  {
           /* tk = token->mark[k][0]; */
	   cl = tabp[i].dominio[k];
	   if(IS_UNORDERED(cl) || (IS_ORDERED(cl) && GET_STATIC_SUBCLASS(cl) == 1))
	    tk = get_dynamic_from_total(cl,dyn->low[k]);
	   else
	    tk = dyn->low[k];
           sprintf(buffer,"%d ",tk);
           shift = strlen(buffer);
           if( c_count + shift > MAX_CACHE )
            goto file_string;
 	   sprintf(str,"%d ",tk);
           c_count += shift;
           str += shift;
	  }
         /*tk = token->mark[k][0]; */
	 cl = tabp[i].dominio[k];
	 if(IS_UNORDERED(cl) || (IS_ORDERED(cl) && GET_STATIC_SUBCLASS(cl) == 1))
	  tk = get_dynamic_from_total(cl,dyn->low[k]);
	 else
	  tk = dyn->low[k];
         sprintf(buffer,"%d ",tk);
         shift = strlen(buffer);
         if( c_count + shift > MAX_CACHE )
          goto file_string;
 	 sprintf(str,"%d ",tk);
         c_count += shift;
         str += shift;
	}
      }
     while(nextvec(dyn,tabp[i].comp_num));
#endif
      }/* Posto pieno colorato */
    }/* Per ogni posto */
   if( c_count + 1 > MAX_CACHE )
    goto file_string;
   sprintf(str,"*");
   c_count++;
#ifdef SYMBOLIC
   str++;
   if( c_count + 1 > MAX_CACHE )
    goto file_string;
   sprintf(str,"&");
   c_count++; str++;
   for(i = 0 ; i < ncl; i++)
    if(IS_UNORDERED(i) || (IS_ORDERED(i) && GET_STATIC_SUBCLASS(i) == 1))
     {/* Classe non ordinata */
      for(k = 0 , offset = 0; k < GET_STATIC_SUBCLASS(i); k++)
       {/* Per ogni sottoclasse statica */
        sprintf(buffer,"%d ",GET_NUM_SS(i,k));
        shift = strlen(buffer);
        if( c_count + shift > MAX_CACHE )
         goto file_string;
        sprintf(str,"%d ",GET_NUM_SS(i,k));
        c_count += shift;
        str += shift;
        for(d = 0; d < GET_NUM_SS(i,k); d++)
         {/* Per ogni sottoclasse dinamica */
          sprintf(buffer,"%d ",GET_CARD(i,k,sfl_h->min[i][offset]));
          shift = strlen(buffer);
          if( c_count + shift > MAX_CACHE )
           goto file_string;
          sprintf(str,"%d ",GET_CARD(i,k,sfl_h->min[i][offset++]));
          c_count += shift;
          str += shift;
         }/* Per ogni sottoclasse dinamica */
       }/* Per ogni sottoclasse statica */
     }/* Classe non ordinata */
#endif
   return(c_count);
file_string:
  rewind(string); c_count = 0;
  for(i = 0 ; i < npl ; i++)
   {/* Per ogni posto */
    c_count += fprintf(string,"*");
    if(IS_NEUTRAL(i))
     c_count += fprintf(string,"%d",net_mark[i].total);
    else
    if(IS_FULL(i))
     {/* Posto pieno colorato */
#ifdef COLOURED
      Token_p tk_p;

      for(tk_p = net_mark[i].marking; tk_p != NULL; tk_p = NEXT_TOKEN(tk_p))
       {/* Per ogni token della marcatura */
	c_count += fprintf(string,"%d ",tk_p->molt);
	for (k = 0 ; k < tabp[i].comp_num - 1; k++)
	 c_count += fprintf(string,"%d ",tk_p->id[k]);
	c_count += fprintf(string,"%d ",tk_p->id[k]);
       }/* Per ogni token della marcatura */
#endif
#ifdef SYMBOLIC
     for (k = 0 ; k < tabp[i].comp_num ; k++)
      {
       dyn->low[k] = token->low[k] = token->up[k] = 0;
       cl = tabp[i].dominio[k];
       if(IS_UNORDERED(cl) || (IS_ORDERED(cl) && GET_STATIC_SUBCLASS(cl) == 1))
        dyn->up[k] = GET_NUM_CL(cl) - 1;
       else
        dyn->up[k] = tabc[cl].card - 1;
      }
     do
      {
       for (k = 0 ; k < tabp[i].comp_num ; k++)
	{
	 cl = tabp[i].dominio[k];
	 if(IS_UNORDERED(cl) || (IS_ORDERED(cl) && GET_STATIC_SUBCLASS(cl) == 1))
	  token->mark[k][0] = sfl_h->min[cl][dyn->low[k]];
	 else
	  token->mark[k][0] = dyn->low[k];
	}
       molt = get_marking_of(token,i,TRUE);
       if(molt)
	{
	 c_count += fprintf(string,"%d ",molt);
 	 for (k = 0 ; k < tabp[i].comp_num - 1; k++)
	  {
	   cl = tabp[i].dominio[k];
	   if(IS_UNORDERED(cl) || (IS_ORDERED(cl) && GET_STATIC_SUBCLASS(cl) == 1))
	    tk = get_dynamic_from_total(cl,dyn->low[k]);
	   else
	    tk = dyn->low[k];
           c_count += fprintf(string,"%d ",tk);
	  }
	 cl = tabp[i].dominio[k];
	 if(IS_UNORDERED(cl) || (IS_ORDERED(cl) && GET_STATIC_SUBCLASS(cl) == 1))
	  tk = get_dynamic_from_total(cl,dyn->low[k]);
	 else
	  tk = dyn->low[k];
         c_count += fprintf(string,"%d ",tk);
	}
      }
     while(nextvec(dyn,tabp[i].comp_num));
#endif
     }/* Posto pieno colorato */
   }/* Per ogni posto */
  c_count += fprintf(string,"*");
#ifdef SYMBOLIC
  c_count += fprintf(string,"&");
  for(i = 0; i < ncl; i++)
   if(IS_UNORDERED(i) || (IS_ORDERED(i) && GET_STATIC_SUBCLASS(i) == 1))
    {/* Classe non ordinata */
     for(k = 0,offset=0; k < GET_STATIC_SUBCLASS(i); k++)
      {/* Per ogni sottoclasse statica */
       c_count += fprintf(string,"%d ",GET_NUM_SS(i,k));
       for(d = 0; d < GET_NUM_SS(i,k); d++)
        {/* Per ogni sottoclasse dinamica */
         c_count += fprintf(string,"%d ",GET_CARD(i,k,sfl_h->min[i][offset++]));
        }/* Per ogni sottoclasse dinamica */
      }/* Per ogni sottoclasse statica */
    }/* Classe non ordinata */
#endif
  return(c_count);
 }/* End marking_to_string */
#endif
