# include <stdio.h>
# include "../../INCLUDE/const.h"
# include "../../INCLUDE/struct.h"
# include "../../INCLUDE/var_ext.h"
# include "../../INCLUDE/macros.h"

#ifdef REACHABILITY
extern char *emalloc();
extern char *ecalloc();

#ifdef DEBUG_malloc
static int result_mall = 0;
static int result_pop = 0;
static int result_push = 0;

static int markinfo_mall_tot = 0;
static int markinfo_pop_tot = 0;

static int throu_mall_tot = 0;
static int throu_pop_tot = 0;
static int throu_push_tot = 0;

static int rate_mall_tot = 0;
static int rate_pop_tot = 0;
static int rate_push_tot = 0;

static int treenode_mall_tot = 0;
static int treenode_pop_tot = 0;

#endif

static Result_p result_free = NULL;   /* Free list per le result */
static MRate_p rate_free = NULL;   /* Free list per le result */
static Throughput_p throu_free = NULL;   /* Free list per le result */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
Result_p pop_result()
 {/* Init pop_result */
  Result_p ret_ptr = NULL;
 
#ifdef DEBUG_malloc
  result_pop++;
#endif
  if(result_free == NULL)
   {/* Lista libera vuota */
    ret_ptr = (Result_p)emalloc(sizeof(struct RESULT));
#ifdef DEBUG_malloc
  result_mall++;
#endif
   }/* Lista libera vuota */
  else
   {
    ret_ptr = result_free;
    result_free = result_free->next;
   }
  ret_ptr->list = NULL;
  ret_ptr->next = NULL;
  ret_ptr->hold = FALSE;
  return(ret_ptr);
 }/* End pop_result */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void push_result(result_ptr)
 Result_p result_ptr;
 {/* Init push_result */
 
#ifdef DEBUG_malloc
  result_push++;
#endif
  result_ptr->next = result_free;
  result_free = result_ptr;
 }/* End push_result */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
MInfo_p markinfo_pop(string_length)
 int string_length;
 {/* Init markinfo_pop */
  MInfo_p ptr;

#ifdef DEBUG_malloc
  markinfo_pop_tot++;
  markinfo_mall_tot++;
#endif
  ptr=(MInfo_p)emalloc(sizeof(struct MARKING_INFO));
  ptr->marking_as_string = (char *)ecalloc(string_length+1,sizeof(char));
  ptr->cont_tang = ptr->pri = UNKNOWN;
#ifdef SYMBOLIC
  ptr->ordinary = UNKNOWN;
#endif
  return(ptr);
 }/* End markinfo_pop */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void push_throu_list(throu_head,throu_tail)
 Throughput_p throu_head;
 Throughput_p throu_tail;
 {/* Init push_throu_list */
  if(throu_head!=NULL)
   {
    throu_tail->next = throu_free;
    throu_free = throu_head;
   }
 }/* End push_throu_list */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void push_throu_element(throu_ptr)
 Throughput_p throu_ptr;
 {/* Init push_throu_element */
 
#ifdef DEBUG_malloc
  throu_push_tot++;
#endif
  throu_ptr->next = throu_free;
  throu_free = throu_ptr;
 }/* End push_throu_element */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
Throughput_p throu_pop()
 {/* Init throu_pop */
  Throughput_p ptr;

#ifdef DEBUG_malloc
  throu_pop_tot++;
#endif
  if(throu_free == NULL)
   {
#ifdef DEBUG_malloc
    throu_mall_tot++;
#endif
    ptr=(Throughput_p)emalloc(sizeof(struct MARC_RAGG));
    ptr->tr = UNKNOWN;
    ptr->weight = UNKNOWN;
    ptr->next = NULL;
   }
  else
   {
    ptr = throu_free;
    throu_free = throu_free->next;
   }
  return(ptr);
 }/* End throu_pop */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void push_rate_list(rate_head,rate_tail)
 MRate_p rate_head;
 MRate_p rate_tail;
 {/* Init push_rate_list */
  if(rate_head!=NULL)
   {
    rate_tail->next = rate_free;
    rate_free = rate_head;
   }
 }/* End push_rate_list */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void push_rate_element(rate_ptr)
 MRate_p rate_ptr;
 {/* Init push_rate_element */
 
#ifdef DEBUG_malloc
  rate_push_tot++;
#endif
  rate_ptr->next = rate_free;
  rate_free = rate_ptr;
 }/* End push_rate_element */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
MRate_p rate_pop()
 {/* Init rate_pop */
  MRate_p ptr;

#ifdef DEBUG_malloc
  rate_pop_tot++;
#endif
  if(rate_free == NULL)
   {
#ifdef DEBUG_malloc
    rate_mall_tot++;
#endif
    ptr=(MRate_p)emalloc(sizeof(struct MARC_RAGG));
    ptr->cont_tang = UNKNOWN;
    ptr->mean_t = UNKNOWN;
    ptr->next = NULL;
   }
  else
   {
    ptr = rate_free;
    rate_free = rate_free->next;
   }
  return(ptr);
 }/* End rate_pop */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
Tree_p treenode_pop(string_length)
 int string_length;
 {/* Init treenode_pop */
  Tree_p ptr;

#ifdef DEBUG_malloc
  treenode_pop_tot++;
  treenode_mall_tot++;
#endif
  ptr = (Tree_p)emalloc(sizeof(struct TREE));
  ptr->marking = markinfo_pop(string_length);
  ptr->enabled_head = NULL;
  ptr->last = ptr->left = ptr->right = NULL;
  ptr->balance = UNKNOWN;
  return(ptr);
 }/* End treenode_pop */

#ifdef DEBUG_malloc
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void out_reach_info()
 {/* Init out_reach_info */
  fprintf(stdout,"--------------- RESULT STRUCTURE ------------------\n");
  fprintf(stdout,"MALLOC %d\nPUSH %d\nPOP %d\n"
         ,result_mall,result_push,result_pop);
  fprintf(stdout,"--------------- MARKING INFO STRUCTURE ------------------\n");
  fprintf(stdout,"MALLOC %d\nPOP %d\n"
	 ,markinfo_mall_tot,markinfo_pop_tot);
  fprintf(stdout,"--------------- RATE PATH STRUCTURE ------------------\n");
  fprintf(stdout,"MALLOC %d\nPUSH %d\nPOP %d\n"
	 ,rate_mall_tot,rate_push_tot,rate_pop_tot);
  fprintf(stdout,"--------------- THROUGHPUT PATH STRUCTURE ------------------\n");
  fprintf(stdout,"MALLOC %d\nPUSH %d\nPOP %d\n"
	 ,throu_mall_tot,throu_push_tot,throu_pop_tot);
  fprintf(stdout,"--------------- TREE NODE STRUCTURE ------------------\n");
  fprintf(stdout,"MALLOC %d\nPOP %d\n"
	 ,treenode_mall_tot,treenode_pop_tot);
 }/* End out_reach_info */
#endif
#endif
