#include <stdio.h>
#include "../../INCLUDE/const.h"
#include "../../INCLUDE/struct.h"
#include "../../INCLUDE/var_ext.h"
#include "../../INCLUDE/macros.h"

#ifdef REACHABILITY
extern Tree_p treenode_pop();

extern Tree_p reached_marking;
extern int cur_priority;

extern char cache_string[];
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void inqueue_stack(top,bottom,ins_node)
 Tree_p *top;
 Tree_p *bottom;
 Tree_p ins_node;
 {/* Init inqueue_stack */
  ins_node->last = NULL;
  if (*top == NULL)
   *top = ins_node;
  else
   (*bottom)->last = ins_node;
  *bottom = ins_node;
 }/* End inqueue_stack */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void pop(top)
 Tree_p *top;
 {/* Init pop */
  *top = (*top)->last;
 }/* End pop */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
static void my_strcpy(string_mark,length)
 char *string_mark;
 int length;
 {/* Init my_strcpy */
  if( length > MAX_CACHE )
   {
    rewind(string);
    fgets(string_mark,length+1,string);
    string_mark[length] = '\0';
  }
  else
   strcpy(string_mark,cache_string);
 }/* End my_strcpy */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
static int my_strcmp(string_mark,len1)
 char *string_mark;
 int len1;
 {/* Init my_strcmp */
  int op1;
  int op2;
  int len2;
  int ii,min;

  if(len1 > MAX_CACHE)
   {
    len2 = strlen(string_mark);
    min = MIN(len1,len2);
    rewind(string);
    for(ii = 0; ii < min; ii++)
     {
      op1 = fgetc( string );
      op2 = string_mark[ii];
      if(op1 < op2)
       return(1);
      if(op1 > op2)
       return(-1);
     }
    if(len1 < len2) 
     return(1);
    else if(len1 > len2)
     return(-1);
    else 
     return(0);
    }
  else
   return(strcmp(string_mark,cache_string));
 }/* End my_strcmp */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
static void insert_node(tree_node,length)
 Tree_p tree_node;
 int length;
 {/* Init insert_node */

  my_strcpy(tree_node->marking->marking_as_string,length);
  ++marcatura;
#ifdef SYMBOLIC
  tree_node->marking->ordinary = mark_ordinarie;
#endif
 }/* End insert_node */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void insert_tree(root,h,length)
 Tree_p *root;
 int *h;
 int length;
 {/* Init insert_tree */
  int marking_pri;
  Tree_p p1;
  Tree_p p2;
  Tree_p ins_node;

  if(*root == NULL)
   {/* Albero vuoto */
    ins_node = treenode_pop(length);

    (*root) = ins_node;
    reached_marking = current_marking = ins_node;
    *h = 1;
    (*root)->left = (*root)->right = NULL;
    (*root)->balance = '0';
    insert_node(*root,length);
    tro = NEW_MARKING;
#ifndef GREATSPN
    /*	fprintf(stdout," %6d\r",marcatura); */	
#endif
   }/* Albero vuoto */
  else if(my_strcmp((*root)->marking->marking_as_string,length) < 0)
   {/* Albero pieno */
    insert_tree(&((*root)->left),h,length);
    if (*h)
     {/* il ramo sinistro e' piu' pesante */
      if ((*root)->balance == '+')
       {
	(*root)->balance = '0';
	*h = 0;
       }
      else if ((*root)->balance == '0')
	    (*root)->balance = '-';
	   else
	    {/* ribilanciamento */
	     p1 = (*root)->left;
	     if (p1->balance == '-')
	      { /* singola rotazione LL */
	       (*root)->left = p1->right;
	       p1->right = (*root);
	       (*root)->balance = '0';
	       (*root) = p1;
	      } /* singola rotazione LL */
	     else
	      { /* doppia rotazione LR */
	       p2 = p1->right;
	       p1->right = p2->left;
	       p2->left = p1;
	       (*root)->left = p2->right;
	       p2->right = (*root);
	       if (p2->balance == '-')
		(*root)->balance = '+';
	       else
		(*root)->balance = '0';
	       if (p2->balance == '+')
		p1->balance = '-';
	       else
		p1->balance = '0';
	       (*root) = p2;
	      } /* doppia rotazione LR */
	     (*root)->balance = '0';
	     *h = 0;
	    }/* ribilanciamento */
     }/* il ramo sinistro e' piu' pesante */
   }/* Albero pieno */
  else if(my_strcmp((*root)->marking->marking_as_string,length) > 0)
   {/* Albero pieno */
    insert_tree(&((*root)->right),h,length);
    if (*h)
     {/* il ramo destro e' piu' pesante */
      if ((*root)->balance == '-')
       {
	(*root)->balance = '0';
	*h = 0;
       }
      else if ((*root)->balance == '0')
	    (*root)->balance = '+';
	   else
	    {/* ribilanciamento */
	     p1 = (*root)->right;
	     if (p1->balance == '+')
	      { /* singola rotazione RR */
	       (*root)->right = p1->left;
	       p1->left = (*root);
	       (*root)->balance = '0';
	       (*root) = p1;
	      } /* singola rotazione RR */
	     else
	      { /* doppia rotazione RL */
	       p2 = p1->left;
	       p1->left = p2->right;
	       p2->right = p1;
	       (*root)->right = p2->left;
	       p2->left = (*root);
	       if (p2->balance == '+')
		(*root)->balance = '-';
	       else
		(*root)->balance = '0';
	       if (p2->balance == '-')
		p1->balance = '+';
	       else
		p1->balance = '0';
	       (*root) = p2;
	      } /* doppia rotazione RL */
	     (*root)->balance = '0';
	     *h = 0;
	    }/* ribilanciamento */
     }/* il ramo destro e' piu' pesante */
   }/* Albero pieno */
  else
   {
    reached_marking = current_marking = (*root);
    marking_pri = reached_marking->marking->pri;
    if(IS_VANISHING(marking_pri))
     tro = VANISHING_OLD;
    else if(IS_TANGIBLE(marking_pri))
     {
      tro = TANGIBLE_OLD;
      cont_tang = reached_marking->marking->cont_tang;
     }
    else
     tro = DEAD_OLD;
    *h = 0;
   }
 }/* End insert_tree */
#endif
