#include <stdio.h>
#include "../../INCLUDE/const.h"
#include "../../INCLUDE/struct.h"
#include "../../INCLUDE/var_ext.h"
#include "../../INCLUDE/macros.h"

#ifdef REACHABILITY


extern  void store_compact();
extern  void load_compact();
extern  void store_double();
extern  void load_double();

extern void initialize_en_list();
extern void update_en_list();
extern void fire_trans();
extern void push_result();
extern void write_ctrs();
extern void write_grg();
extern void write_on_srg();
extern void write_final_results();
extern void update_rg_files();
extern void out_cur_marking();
extern void string_to_marking();

extern unsigned long marking_to_string();

extern MRate_p rate_pop();

extern Event_p get_new_event();

static Tree_p fire_ptr = NULL;	 /* Puntatore alla marcatura di sparo	 */
static Tree_p top = NULL;	 /* Puntatori al top e al bottom dello	 */
static Tree_p bottom = NULL;	 /* Stack di marcature da espandere	 */
static Tree_p root = NULL;	 /* Albero delle marcature raggiunte	 */

Tree_p reached_marking = NULL;
Tree_p initial_marking = NULL;
Tree_p current_marking = NULL;

Result_p enabled_head = NULL;	/* Puntatori alla lista delle tr. abil. */

int tro;			/* 1 marc. gia' raggiunta, 0 altrimenti */
int marcatura = 0;	/* contatore per le marcature		*/
int h = 0;			/* per bilanciamento nella insert_tree	*/
unsigned long tang = 0;		/* contatori tipi di marc. raggiunte	*/
unsigned long evan = 0;
unsigned long dead = 0;
int home = 0;
unsigned long cont_tang;
int count_arc = 0;
#ifdef SYMBOLIC
extern void create_canonical_data_structure();
extern void get_canonical_marking();

double mark_ordinarie;	    /* num. marc. ord. per marc. simbolica  */
double ord_tang = 0.0;
double ord_evan = 0.0;
double ord_dead = 0.0;

extern Canonic_p sfl_h;
#endif

int cur_priority;

int *code_place = NULL;
int *min_place = NULL;
int *max_place = NULL;
int *init_place = NULL;

int max_priority = 0;
int old_time,new_time;

static MRate_p path_head_ptr = NULL;
static MRate_p path_tail_ptr = NULL;

static MRate_p tangible_path_head_ptr = NULL;
static MRate_p tangible_path_tail_ptr = NULL;

static Throughput_p throu_head_ptr = NULL;
static Throughput_p throu_tail_ptr = NULL;

static Throughput_p total_throu_head_ptr = NULL;
static Throughput_p total_throu_tail_ptr = NULL;

static unsigned long tot_path = 0;
 
unsigned long d_ptr;
unsigned long length;
unsigned long f_mark;
int f_bot;
int f_throu;
int f_tang;

int out_mc = FALSE;

#define DEBUGWNGR 2

#ifndef DEBUGWNGR
FILE *wnfp,*trsfp;
#endif
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
static void arrcpy(s,t,lim)
 int *s,*t;
 {/* Init arrcpy */
  int i;

  for( i = lim ; i ; i-- )
   s[i-1] = t[i-1];
 }/* End arrcpy */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
static void append_to_list_of_throu(head,tail,add_head,add_tail)
 Throughput_p *head;
 Throughput_p *tail;
 Throughput_p add_head;
 Throughput_p add_tail;
 {/* Init append_to_list_of_throu */
  Throughput_p list = NULL;
  Throughput_p cur = NULL;
  Throughput_p nxt = NULL;
  int found = FALSE;

  if(*head == NULL && *tail==NULL)
   {
    *head = add_head;
    *tail = add_tail;
   }
  else
   {
    for( cur = add_head; cur != NULL; cur = nxt)
     {
      nxt = cur->next;
      found = FALSE;
      for(list = *head; list != NULL; list = list->next)
       if(cur->tr == list->tr)
        {
         found = TRUE;
         list->weight += cur->weight;
         push_throu_element(cur);
         goto finish;
        }
finish:if(found == FALSE)
       {
        (*tail)->next = cur;
         *tail = cur;
        (*tail)->next = NULL;
       }
     }
   }
  if((*tail) != NULL)
   (*tail)->next = NULL;

 }/* End append_to_list_of_throu */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
static void append_to_list_of_tangible_reachable(head,tail,add_head,add_tail)
 MRate_p *head;
 MRate_p *tail;
 MRate_p add_head;
 MRate_p add_tail;
 {/* Init append_to_list_of_tangible_reachable */
  MRate_p list = NULL;
  MRate_p cur = NULL;
  MRate_p nxt = NULL;
  int found = FALSE;

  if(*head == NULL && *tail==NULL)
   {
    *head = add_head;
    *tail = add_tail;
   }
  else
   {
    for( cur = add_head; cur != NULL; cur = nxt)
     {
      nxt = cur->next;
      found = FALSE;
      for(list = *head; list != NULL; list = list->next)
       if(cur->cont_tang == list->cont_tang && cur->flag==list->flag)
        {
         found = TRUE;
         list->mean_t += cur->mean_t;
         push_rate_element(cur);
         goto finish;
        }
finish:if(found == FALSE)
       {
        (*tail)->next = cur;
         *tail = cur;
        (*tail)->next = NULL;
       }
     }
   }
  if((*tail) != NULL)
   (*tail)->next = NULL;
 }/* End append_to_list_of_tangible_reachable */

/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
static void dispose_all_instances(res_ptr)
 Result_p res_ptr;
 {/* Init dispose_all_instances */
  Event_p ev_p,nev_p;

  if(res_ptr != NULL)
   {/* Puntatore consistente */
    ev_p = res_ptr->list;
    while (ev_p != NULL)
     {
      nev_p = ev_p->next;
      dispose_old_event(ev_p);
      ev_p = nev_p;
     }
   }/* Puntatore consistente */
 }/* End dispose_all_instances */
/* ********************************************************************* */
/*                                                                       */
/*    Funzioni che permettono il calcolo dei tassi associati alle        */
/*    transizioni abilitate                                              */
/*                                                                       */
/* ********************************************************************* */
static double normalizzazione(pun,pri)
Result_p pun;
int pri;
{
 double prod;
 double den = 0;
 Event_p ev_p = NULL;
 int tr;

 while (pun != NULL)
  {/* Per ogni transizione */
   ev_p = pun->list;
   prod = 0;
   tr = GET_TRANSITION_INDEX(ev_p);
   if(tabt[tr].pri == pri)
    {/* Se sono allo stesso livello di priorita' */
     while(ev_p != NULL)
      {/* Per ogni istanza */
       tr = GET_TRANSITION_INDEX(ev_p);
       prod += tabt[tr].mean_t * GET_ENABLING_DEGREE(ev_p);
       ev_p = NEXT_EVENT(ev_p);
      }/* Per ogni istanza */
     den += prod;
    }/* Se sono allo stesso livello di priorita' */
   pun = pun->next;
  }/* Per ogni transizione	*/
 return(den);
}
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
static void garbage_collect(fire_ptr)
 Tree_p fire_ptr;
 {/* Init garbage_collect */
  Result_p current_transition,next_transition;

  current_transition = fire_ptr->enabled_head;
  while (current_transition != NULL)
   {
    next_transition = current_transition->next;
    dispose_all_instances(current_transition);
    current_transition->list = NULL;
    push_result(current_transition);
    current_transition = next_transition;
   }
  fire_ptr->enabled_head = NULL;
 }/* End garbage_collect */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void DFS_evanescenti(f_mark)
 int f_mark;
 {/* Init DFS_evanescenti */
  char cc;
  int tr;
  int marking_pri;

  Result_p current_transition;

  Event_p ev_p,nev_p,copy_of_ev_p;

  Tree_p new_reached_marking;
  Tree_p dfs_fire_ptr;

  MRate_p pun = NULL;
  MRate_p cur = NULL;
  MRate_p marc_ragg = NULL;
  MRate_p head_marc = NULL;
  MRate_p tail_marc = NULL;
  Throughput_p pun_throu = NULL;
  Throughput_p cur_throu = NULL;
  Throughput_p throu_ragg = NULL;
  Throughput_p head_throu = NULL;
  Throughput_p tail_throu = NULL;
  int tot_p = 0;
  int temp_p ;
 
  int nmark;
  int nk;
  int st;
  double ra;
  int tnmark;
  int tnk;
  int tst;
  double tra;
  double dval;


  double denom,numer,mean_t;

  dfs_fire_ptr = new_reached_marking = reached_marking;
  marking_pri = dfs_fire_ptr->marking->pri;

  if(IS_VANISHING(marking_pri) && out_mc)
   denom = normalizzazione(dfs_fire_ptr->enabled_head,marking_pri);
  current_transition = dfs_fire_ptr->enabled_head;
  while (current_transition != NULL)
   {/* per tutte le transizioni abilitate */
    tr = GET_TRANSITION_INDEX(current_transition->list);
    if(tabt[tr].pri == marking_pri)
     {/* Solo per la stessa priorita' */
      copy_of_ev_p = get_new_event(tr);
      ev_p = current_transition->list;
      while(ev_p != NULL)
       {/* per ogni istanza */
	nev_p = ev_p->next;
	if(output_flag)
	 {/* Scrittura abilitata */
	  update_rg_files(TANGIBLE_OR_VANISHING,dfs_fire_ptr,tr,marking_pri);
	 }/* Scrittura abilitata */
	if(out_mc)
	 {/* Construction of Markov Chain */
	  numer = GET_ENABLING_DEGREE(ev_p) * tabt[tr].mean_t;
	  if(IS_VANISHING(marking_pri))
	   mean_t = numer/denom;
	  else
	   mean_t = numer;
	 }/* Construction of Markov Chain */
	copy_event(copy_of_ev_p,ev_p);
	fire_trans(ev_p);
	if(output_flag)
	 {/* Scrittura abilitata */
	  out_single_instance(ev_p,srg);
	  if(out_mc)
	   {/* Construction of Markov Chain */
	    fprintf(srg,"--->   (rate %lg)\n",mean_t);
	   }/* Construction of Markov Chain */
	 }/* Scrittura abilitata */
#ifdef SYMBOLIC
        get_canonical_marking();
#endif
	f_mark = marking_to_string();
	tro = 0;
	insert_tree(&root,&h,f_mark,length,d_ptr); /* Piu' info nel symbolic */
	if (current_marking == initial_marking && !home)
	 home = 1;
	switch(tro)
	 {/* Vari tipi di marcatura raggiunta */
	  case DEAD_OLD:
	       if(output_flag)
		{/* Scrittura abilitata */
		 update_rg_files(NORMAL,NULL,UNKNOWN,-1);
		}/* Scrittura abilitata */
	       break;
	  case VANISHING_OLD:
	       if(output_flag)
		{/* Scrittura abilitata */
		 update_rg_files(NORMAL,NULL,UNKNOWN,1);
		}/* Scrittura abilitata */
	       if(out_mc)
		{/* Construction of Markov Chain */


		   marc_ragg = rate_pop();
		   marc_ragg->flag = TRUE;
		   marc_ragg->cont_tang = reached_marking->marking->path;
		   marc_ragg->mean_t =  mean_t;
		   marc_ragg->next = NULL;
		   append_to_list_of_tangible_reachable(&head_marc,&tail_marc,marc_ragg,marc_ragg);

		 fseek(rht,reached_marking->marking->throu,0);
		 load_compact(&tnmark,rht);
		 /*fscanf(rht,"%d",&tnmark);*/
		 for( tnk = 1; tnk <= tnmark; tnk++)
		  {
		   load_compact(&tst,rht);
		   load_double(&tra,rht);
		   /*fscanf(rht,"%d %lg",&tst,&tra);*/
		   throu_ragg = throu_pop();
		   throu_ragg->tr = tst;
		   throu_ragg->weight = tra * mean_t;
		   throu_ragg->next = NULL;
		   append_to_list_of_throu(&head_throu,&tail_throu,throu_ragg,throu_ragg);
		  }
                 if(tabt[tr].tagged)
	          {
		   throu_ragg = throu_pop();
		   throu_ragg->tr = tr;
		   throu_ragg->weight = mean_t;
		   throu_ragg->next = NULL;
		   append_to_list_of_throu(&head_throu,&tail_throu,throu_ragg,throu_ragg);
	          }
		}/* Construction of Markov Chain */

	       break;
	  case TANGIBLE_OLD:
	       if(output_flag)
		{/* Scrittura abilitata */
		 update_rg_files(NORMAL,NULL,UNKNOWN,0);
		}/* Scrittura abilitata */
	       if(out_mc)
		{/* Construction of Markov Chain */
		 marc_ragg = rate_pop();
		 marc_ragg->cont_tang = cont_tang;
		 marc_ragg->flag = FALSE;
		 marc_ragg->mean_t = mean_t;
		 marc_ragg->next = NULL;
		 append_to_list_of_tangible_reachable(&head_marc,&tail_marc,marc_ragg,marc_ragg);
                 if(tabt[tr].tagged)
	          {
		   throu_ragg = throu_pop();
		   throu_ragg->tr = tr;
		   throu_ragg->weight =  mean_t;
		   throu_ragg->next = NULL;
		   append_to_list_of_throu(&head_throu,&tail_throu,throu_ragg,throu_ragg);
	          }
		}/* Construction of Markov Chain */
	       break;
	  case VANISHING_LOOP:
	       fprintf(stdout,"ERRORE : CICLO DI EVANESCENTI \n");
	       exit(1);
	       break;
	  case NEW_MARKING:
	       enabled_head = NULL;
#ifdef SYMBOLIC
               string_to_marking(reached_marking->marking->marking_as_string,reached_marking->marking->d_ptr,reached_marking->marking->length);
#endif
	       update_en_list(ev_p,dfs_fire_ptr->enabled_head);
	       if(enabled_head == NULL)
		{/* Dead marking */
		 reached_marking->marking->cont_tang = ++dead;
		 reached_marking->marking->pri = -1;
#ifdef SYMBOLIC
		 ord_dead += mark_ordinarie;
#endif
		 if(output_flag)
		  update_rg_files(DEAD,NULL,UNKNOWN,UNKNOWN);
		}/* Dead marking */
               else
		{/* Live marking */
		 reached_marking->marking->pri = cur_priority;
	         if(!cur_priority)
		  {/* Marcatura tangibile */
		   tang++;
#ifdef SYMBOLIC
		   ord_tang += mark_ordinarie;
#endif
		   inqueue_stack(&top,&bottom,reached_marking);
		   reached_marking->enabled_head = enabled_head;
		   reached_marking->marking->cont_tang = tang;
		   if(output_flag)
		    {/* Scrittura abilitata */
		     update_rg_files(NORMAL,NULL,UNKNOWN,cur_priority);
		    }/* Scrittura abilitata */
		   if(out_mc)
		    {/* Construction of Markov Chain */
		     marc_ragg = rate_pop();
		     marc_ragg->cont_tang = tang;
		     marc_ragg->flag = FALSE;
		     marc_ragg->mean_t = mean_t;
		     marc_ragg->next = NULL;
		     append_to_list_of_tangible_reachable(&head_marc,&tail_marc,marc_ragg,marc_ragg);
                     if(tabt[tr].tagged)
	              {
		       throu_ragg = throu_pop();
		       throu_ragg->tr = tr;
		       throu_ragg->weight =  mean_t;
		       throu_ragg->next = NULL;
		       append_to_list_of_throu(&head_throu,&tail_throu,throu_ragg,throu_ragg);
	              }
		    }/* Construction of Markov Chain */
		  }/* Marcatura tangibile */
	         else
		  {/* Marcatura evanescente */
		   evan++;
#ifdef SYMBOLIC
		   ord_evan += mark_ordinarie;
#endif
		   reached_marking->enabled_head = enabled_head;
		   reached_marking->marking->cont_tang = evan;
		   if(output_flag)
		    {/* Scrittura abilitata */
		     update_rg_files(NORMAL,NULL,UNKNOWN,cur_priority);
		    }/* Scrittura abilitata */
		   DFS_evanescenti(f_mark);
		   if(out_mc)
		    {/* Construction of Markov Chain */
		     pun = path_head_ptr;
		     while (pun != NULL)
		      {
		       pun->mean_t *= mean_t;
		       pun = pun->next;
		      }
		     append_to_list_of_tangible_reachable(&head_marc,&tail_marc,path_head_ptr,path_tail_ptr);
		     path_head_ptr = NULL;
		     path_tail_ptr = NULL;

		     pun_throu = throu_head_ptr;
		     while (pun_throu != NULL)
		      {
		       pun_throu->weight *= mean_t;
		       pun_throu = pun_throu->next;
		      }
		     append_to_list_of_throu(&head_throu,&tail_throu,throu_head_ptr,throu_tail_ptr);
                     if(tabt[tr].tagged)
	              {
		       throu_ragg = throu_pop();
		       throu_ragg->tr = tr;
		       throu_ragg->weight =  mean_t;
		       throu_ragg->next = NULL;
		       append_to_list_of_throu(&head_throu,&tail_throu,throu_ragg,throu_ragg);
	              }
		     throu_head_ptr = NULL;
		     throu_tail_ptr = NULL;
		    }/* Construction of Markov Chain */
		  }/* Marcatura evanescente */
		}/* Live marking */
	       break;
	 }/* Vari tipi di marcatura raggiunta */
#ifdef SYMBOLIC
	string_to_marking(dfs_fire_ptr->marking->marking_as_string,dfs_fire_ptr->marking->d_ptr,dfs_fire_ptr->marking->length);
#endif
#ifdef COLOURED
	string_to_marking(dfs_fire_ptr->marking->marking_as_string,UNKNOWN,dfs_fire_ptr->marking->length);
#endif
        ev_p = nev_p;
       }/* per ogni istanza */
      dispose_old_event(copy_of_ev_p);
     }/* Solo per la stessa priorita' */
    current_transition = current_transition->next;
   }/* Per tutte le transizioni abilitate */
  if(out_mc)
   {/* Construction of Markov Chain */
    if(new_reached_marking != NULL)
     {
      new_reached_marking->marking->path = ftell(van_path);
      /*fseek(van_path,f_bot,0);*/
      cur = head_marc;tot_path = 0;
      for(;cur!=NULL;cur=cur->next)
       tot_path++;
      store_compact(tot_path,van_path);
#ifndef DEBUGWNGR
fprintf(trsfp,"%d",tot_path);
#endif

      cur = head_marc;
      for( ; cur != NULL ; cur = pun)
       {
	pun = cur->next;
#ifndef DEBUGWNGR
fprintf(trsfp," %d",cur->cont_tang);
#endif
        store_compact(cur->cont_tang,van_path);
	if(cur->flag==FALSE)
	 {
	  dval = cur->mean_t;
#ifndef DEBUGWNGR
fprintf(trsfp," %lg",dval);
#endif
          store_double(&dval,van_path);
	 }
	else
	 {
          /*dval = -cur->mean_t - 1.0;*/
          dval = -cur->mean_t ;
#ifndef DEBUGWNGR
fprintf(trsfp," %lg",dval);
#endif
          store_double(&dval,van_path);
	 }
       }
#ifndef DEBUGWNGR
fprintf(trsfp,"\n");
#endif

      /*f_bot = ftell(van_path);*/
      append_to_list_of_tangible_reachable(&path_head_ptr,&path_tail_ptr,head_marc,tail_marc);
      head_marc = tail_marc = NULL;

      new_reached_marking->marking->throu = f_throu;
      fseek(rht,f_throu,0); 

      cur_throu = head_throu; tot_path = 0;
      for(;cur_throu!=NULL;cur_throu=cur_throu->next)
       tot_path++;
      store_compact(tot_path,rht);
      /*fprintf(rht,"%d",tot_path);*/
      cur_throu = head_throu;
      for(tnk = 1 ; tnk <= tot_path; tnk++,cur_throu = pun_throu)
       {
	pun_throu = cur_throu->next;
	store_compact(cur_throu->tr,rht);
	dval = cur_throu->weight;
	store_double(&dval,rht);
	/*fprintf(rht," %d %lg",cur_throu->tr,cur_throu->weight);*/
       }
      f_throu = ftell(rht);
      append_to_list_of_tangible_reachable(&throu_head_ptr,&throu_tail_ptr,head_throu,tail_throu);
      head_throu = tail_throu = NULL;
     }
   }/* Construction of Markov Chain */
  garbage_collect(dfs_fire_ptr);
 }/* End DFS_evanescenti */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void build_graph()
 {/* Init build_graph */
  char cc;
  int j;
  int tr;


  int marking_pri;
  int first_fire;

  Result_p current_transition;
  Result_p next_transition;

  Event_p ev_p,nev_p,copy_of_ev_p;

  Tree_p new_reached_marking;

  Throughput_p throu_ragg = NULL;
  MRate_p marc_ragg = NULL;

  double denom,numer,mean_t;

  int nmark;
  int nk;
  int st;
  double ra;

  unsigned long tnmark;
  int tnk;
  int tst;
  double tra;
  double dval;


  if(out_mc)
   {/* Construction of Markov Chain */
    /*f_bot = ftell(van_path);*/
    f_throu = ftell(rht);
    fprintf(throu,"%d\n",ntr);
    /*f_tang = ftell(throu);*/
   }/* Construction of Markov Chain */


  tro = 0;
  time(&old_time);
#ifdef SYMBOLIC
  create_canonical_data_structure();
  get_canonical_marking();
#endif
  f_mark = marking_to_string();

  tro = 0; 
  insert_tree(&root,&h,f_mark,length,d_ptr);
  inqueue_stack(&top,&bottom,root);
  initial_marking = root;

#ifdef SYMBOLIC
  string_to_marking(root->marking->marking_as_string,root->marking->d_ptr,root->marking->length);
#endif
#ifdef COLOURED
  string_to_marking(root->marking->marking_as_string,UNKNOWN,root->marking->length);
#endif

  if(output_flag)
   {/* Scrittura abilitata */
    fprintf(srg,"INITIAL MARKING\n");
    write_on_srg(srg,0);
    fprintf(srg,"\n");
   }/* Scrittura abilitata */

  initialize_en_list();  /* Inizializzazione eventi abilitati in M0 */

  if(enabled_head != NULL)
   {/* Marcatura Live */
    root->marking->pri = cur_priority;
    if(IS_TANGIBLE(cur_priority))
     {
      root->marking->cont_tang = ++tang;
#ifdef SYMBOLIC
      ord_tang += mark_ordinarie;
#endif
     }
    else
     {
      root->marking->cont_tang = ++evan;
#ifdef SYMBOLIC
      ord_evan += mark_ordinarie;
#endif
     }
   }/* Marcatura Live */
  else
   {/* Marcatura Dead */
    root->marking->pri = -1;
    root->marking->cont_tang = ++dead;
#ifdef SYMBOLIC
    ord_dead += mark_ordinarie;
#endif
   }/* Marcatura Dead */

  root->enabled_head = enabled_head;

  if(out_mc)
   {/* Construction of Markov Chain */
    for(j=0; j<npl; j++)
     {
      min_place[j] = 255;
      max_place[j] = 0;
     }
    for (j=0; j<ntr; j++)
     if (max_priority < tabt[j].pri)
      max_priority = tabt[j].pri;
    code_marking();
    arrcpy(init_place,code_place,npl);
    fprintf(wngr,"%d\n",cur_priority ? 0 : 1 );
#ifndef DEBUGWNGR
wnfp=efopen("wngr","w");
trsfp=efopen("vanpath","w");
#endif
#ifndef DEBUGWNGR
    fprintf(wnfp,"%d\n",cur_priority ? 0 : 1 );
#endif

   }/* Construction of Markov Chain */

  while (top != NULL)
   {/* per tutte le marcature memorizzate sullo stack */
	/* Khalil: The main loop to build the graph */
    total_throu_head_ptr = NULL;
    total_throu_tail_ptr = NULL;
    tangible_path_head_ptr = NULL;
    tangible_path_tail_ptr = NULL;
    fire_ptr = top;
    marking_pri = fire_ptr->marking->pri;
    pop(&top);
#ifdef SYMBOLIC
    string_to_marking(fire_ptr->marking->marking_as_string,fire_ptr->marking->d_ptr,fire_ptr->marking->length);
#endif
#ifdef COLOURED
    string_to_marking(fire_ptr->marking->marking_as_string,UNKNOWN,fire_ptr->marking->length);
#endif
    if(out_mc)
     {/* Construction of Markov Chain */
      code_marking();
      write_ctrs(ctrs);
      if(IS_VANISHING(marking_pri))
       {/* Marcatura evanascente : fattore di normalizzazione */
	denom = normalizzazione(fire_ptr->enabled_head,marking_pri);
       }/* Marcatura evanascente : fattore di normalizzazione */
     }/* Construction of Markov Chain */
    current_transition = fire_ptr->enabled_head;
    while(current_transition != NULL)
     {/* Per tutte le transizioni abilitate */
      next_transition = current_transition->next;
      tr = GET_TRANSITION_INDEX(current_transition->list);
      if(tabt[tr].pri == marking_pri)
       {/* Solo per transizioni alla stessa priorita' */
	copy_of_ev_p = get_new_event(tr);
	ev_p = current_transition->list;
	while(ev_p != NULL)
	 {/* Per ogni istanza abilitata */
	  nev_p = ev_p->next;
	  if(output_flag)
	   {/* Scrittura abilitata */
	    update_rg_files(TANGIBLE_OR_VANISHING,fire_ptr,tr,marking_pri);
	   }/* Scrittura abilitata */
	  if(out_mc)
	   {/* Construction of Markov Chain */
	    numer = GET_ENABLING_DEGREE(ev_p) * tabt[tr].mean_t;
	    if(IS_VANISHING(marking_pri))
	     mean_t = numer/denom;
	    else
	     mean_t = numer;
	   }/* Construction of Markov Chain */
	  copy_event(copy_of_ev_p,ev_p);
	  fire_trans(ev_p);
	  if(output_flag)
	   {/* Scrittura abilitata */
	    out_single_instance(ev_p,srg);
	    if(out_mc)
	     {/* Construction of Markov Chain */
	      fprintf(srg,"--->   (rate %lg)\n",mean_t);
	     }/* Construction of Markov Chain */
	   }/* Scrittura abilitata */
#ifdef SYMBOLIC
          get_canonical_marking();
#endif
	  f_mark = marking_to_string();
          tro = 0;
	  insert_tree(&root,&h,f_mark,length,d_ptr); /* Piu' info nel symbolic */
	  if (current_marking == initial_marking && !home)
	   home = 1;
	  switch(tro)
	   {/* Vari tipi di marcatura raggiunta */
	    case DEAD_OLD :
		 if(output_flag)
		  {/* Scrittura abilitata */
		   update_rg_files(NORMAL,NULL,UNKNOWN,-1);
		  }/* Scrittura abilitata */
		 break;
	    case VANISHING_OLD :
		 if(output_flag)
		  {/* Scrittura abilitata */
		   update_rg_files(NORMAL,NULL,UNKNOWN,1);
		  }/* Scrittura abilitata */
		 if(out_mc)
		  {/* Construction of Markov Chain */
		   marc_ragg = rate_pop();
		   marc_ragg->flag = TRUE;
		   marc_ragg->cont_tang = reached_marking->marking->path;
		   /*marc_ragg->mean_t =  -mean_t - 1.0;*/
		   marc_ragg->mean_t =  -mean_t ;
		   marc_ragg->next = NULL;
		   append_to_list_of_tangible_reachable(&tangible_path_head_ptr,&tangible_path_tail_ptr,marc_ragg,marc_ragg);

		   fseek(rht,reached_marking->marking->throu,0);
		   load_compact(&tnmark,rht);
		   /*fscanf(rht,"%d",&tnmark);*/
		   for( tnk = 1; tnk <= tnmark; tnk++)
		    {
		     /*fscanf(rht,"%d %lg",&tst,&tra);*/
		     load_compact(&tst,rht);
		     load_double(&tra,rht);
		     throu_ragg = throu_pop();
		     throu_ragg->tr = tst;
		     throu_ragg->weight = tra * mean_t;
		     throu_ragg->next = NULL;
		     append_to_list_of_throu(&total_throu_head_ptr,&total_throu_tail_ptr,throu_ragg,throu_ragg);
		    }
                   if(tabt[tr].tagged)
		    {
		     throu_ragg = throu_pop();
		     throu_ragg->tr = tr;
		     throu_ragg->weight = mean_t;
		     throu_ragg->next = NULL;
		     append_to_list_of_throu(&total_throu_head_ptr,&total_throu_tail_ptr,throu_ragg,throu_ragg);
		    }
		  }/* Construction of Markov Chain */
		 break;
	    case TANGIBLE_OLD :
		 if(output_flag)
		  {/* Scrittura abilitata */
		   update_rg_files(NORMAL,NULL,UNKNOWN,0);
		  }/* Scrittura abilitata */
		 if(out_mc)
		  {/* Construction of Markov Chain */
		   marc_ragg = rate_pop();
		   marc_ragg->flag = FALSE;
		   marc_ragg->cont_tang = cont_tang;
		   marc_ragg->mean_t =  mean_t;
		   marc_ragg->next = NULL;
		   append_to_list_of_tangible_reachable(&tangible_path_head_ptr,&tangible_path_tail_ptr,marc_ragg,marc_ragg);
                   if(tabt[tr].tagged)
		    {
		     throu_ragg = throu_pop();
		     throu_ragg->tr = tr;
		     throu_ragg->weight = mean_t;
		     throu_ragg->next = NULL;
		     append_to_list_of_throu(&total_throu_head_ptr,&total_throu_tail_ptr,throu_ragg,throu_ragg);
		    }
		  }/* Construction of Markov Chain */
		 break;
	    case NEW_MARKING :
		 enabled_head = NULL;
#ifdef SYMBOLIC
		 string_to_marking(reached_marking->marking->marking_as_string,reached_marking->marking->d_ptr,reached_marking->marking->length);
#endif
		 update_en_list(ev_p,fire_ptr->enabled_head);
		 if(enabled_head == NULL)
		  {/* Dead marking */
		   reached_marking->marking->cont_tang = ++dead;
		   reached_marking->marking->pri = -1;
#ifdef SYMBOLIC
		   ord_dead += mark_ordinarie;
#endif
		   if(output_flag)
		    update_rg_files(DEAD,NULL,UNKNOWN,UNKNOWN);
		  }/* Dead marking */
                 else
		  {/* Live Marking */
                   reached_marking->marking->pri = cur_priority;
		   if(!cur_priority)
		    {/* marcatura tangibile */
		     tang++;
#ifdef SYMBOLIC
                     ord_tang += mark_ordinarie;
#endif
		     inqueue_stack(&top,&bottom,reached_marking);
		     reached_marking->enabled_head = enabled_head;
		     reached_marking->marking->cont_tang = tang;
		     if(output_flag)
		      {/* Scrittura abilitata */
		       update_rg_files(NORMAL,NULL,UNKNOWN,cur_priority);
		      }/* Scrittura abilitata */
		     if(out_mc)
		      {/* Construction of Markov Chain */
		   marc_ragg = rate_pop();
		   marc_ragg->flag = FALSE;
		   marc_ragg->cont_tang = tang;
		   marc_ragg->mean_t =  mean_t;
		   marc_ragg->next = NULL;
		   append_to_list_of_tangible_reachable(&tangible_path_head_ptr,&tangible_path_tail_ptr,marc_ragg,marc_ragg);
                       if(tabt[tr].tagged)
		        {
		         throu_ragg = throu_pop();
		         throu_ragg->tr = tr;
		         throu_ragg->weight = mean_t;
		         throu_ragg->next = NULL;
		         append_to_list_of_throu(&total_throu_head_ptr,&total_throu_tail_ptr,throu_ragg,throu_ragg);
		        }
		      }/* Construction of Markov Chain */
		    }/* marcatura tangibile */
		   else
		    {/* marcatura evanescente */
		     evan++;
#ifdef SYMBOLIC
                     ord_evan += mark_ordinarie;
#endif

		     new_reached_marking = reached_marking;
		     reached_marking->enabled_head = enabled_head;
		     reached_marking->marking->cont_tang = evan;
		     if(output_flag)
		      {/* Scrittura abilitata */
		       update_rg_files(NORMAL,NULL,UNKNOWN,cur_priority);
		      }/* Scrittura abilitata */
		     if(out_mc)
		      {/* Construction of Markov Chain */
		       path_head_ptr = NULL;
		       path_tail_ptr = NULL;
                       throu_head_ptr = NULL;
                       throu_tail_ptr = NULL;
		      }/* Construction of Markov Chain */
		     DFS_evanescenti(f_mark);
		     if(out_mc)
		      {/* Construction of Markov Chain */
		   marc_ragg = rate_pop();
		   marc_ragg->flag = TRUE;
		   marc_ragg->cont_tang = new_reached_marking->marking->path;
		   /*marc_ragg->mean_t =  -mean_t - 1.0;*/
		   marc_ragg->mean_t =  -mean_t ;
		   marc_ragg->next = NULL;
		   append_to_list_of_tangible_reachable(&tangible_path_head_ptr,&tangible_path_tail_ptr,marc_ragg,marc_ragg);
		       push_rate_list(path_head_ptr,path_tail_ptr);
                       for( throu_ragg =  throu_head_ptr; throu_ragg != NULL; throu_ragg = throu_ragg->next)
		        throu_ragg->weight *= mean_t;
		       append_to_list_of_throu(&total_throu_head_ptr,&total_throu_tail_ptr,throu_head_ptr,throu_tail_ptr);
                       if(tabt[tr].tagged)
		        {
		         throu_ragg = throu_pop();
		         throu_ragg->tr = tr;
		         throu_ragg->weight = mean_t;
		         throu_ragg->next = NULL;
		         append_to_list_of_throu(&total_throu_head_ptr,&total_throu_tail_ptr,throu_ragg,throu_ragg);
		        }
		      }/* Construction of Markov Chain */
		    }/* Marcatura evanescente */
		  }/* Live Marking */
		 break;
	   }/* Vari tipi di marcatura raggiunta */
#ifdef SYMBOLIC
	  string_to_marking(fire_ptr->marking->marking_as_string,fire_ptr->marking->d_ptr,fire_ptr->marking->length);
#endif
#ifdef COLOURED
	  string_to_marking(fire_ptr->marking->marking_as_string,UNKNOWN,fire_ptr->marking->length);
#endif
	  ev_p = nev_p;
	 }/* Per ogni istanza abilitata */
        dispose_old_event(copy_of_ev_p);
       }/* Solo per transizioni alla stessa priorita' */
      current_transition = next_transition;
     }/* Per tutte le transizioni abilitate */

    if(out_mc)
     {/* Construction of Markov Chain */
      marc_ragg = tangible_path_head_ptr; 
      tnmark = 0;
      for( ; marc_ragg != NULL ; marc_ragg = marc_ragg->next)
       tnmark++;
#ifndef DEBUGWNGR
      fprintf(wnfp,"%d ",tnmark);
#endif
      store_compact(tnmark,wngr);
      marc_ragg = tangible_path_head_ptr; 
      for( ; marc_ragg != NULL ; marc_ragg = marc_ragg->next)
       {
#ifndef DEBUGWNGR
      fprintf(wnfp,"%d ",marc_ragg->cont_tang);
#endif
        store_compact(marc_ragg->cont_tang,wngr);
        dval = marc_ragg->mean_t;
#ifndef DEBUGWNGR
      fprintf(wnfp,"%lg ",dval);
#endif
        store_double(&dval,wngr);
       }
#ifndef DEBUGWNGR
      fprintf(wnfp,"\n");
#endif

      /*fseek(throu,f_tang,0);*/
      throu_ragg = total_throu_head_ptr; 
      tnmark = 0;
      for( ; throu_ragg != NULL ; throu_ragg = throu_ragg->next)
       tnmark++;
      /*fprintf(throu,"%d",tnmark);*/
      store_compact(tnmark,throu);
      throu_ragg = total_throu_head_ptr;
      for(tnk = 1 ; tnk <= tnmark; tnk++,throu_ragg = throu_ragg->next)
       {
       /*fprintf(throu," %d %lg",throu_ragg->tr,throu_ragg->weight);*/
	store_compact(throu_ragg->tr,throu);
	dval = throu_ragg->weight;
	store_double(&dval,throu);
       }
      /*fprintf(throu,"\n");*/
      /*f_tang = ftell(throu);*/

      push_throu_list(total_throu_head_ptr,total_throu_tail_ptr);
      push_rate_list(tangible_path_head_ptr,tangible_path_tail_ptr);
     }/* Construction of Markov Chain */
    garbage_collect(fire_ptr);
   }/* per tutte le marcature memorizzate sullo stack */
  time(&new_time);
  if(out_mc)
   {/* Construction of Markov Chain */
    write_grg(grg);
#ifndef DEBUGWNGR
    fprintf(wnfp,"%d\n",tang+1);
#endif
#ifndef DEBUGWNGR
fclose(wnfp);
fclose(trsfp);
#endif
    fprintf(wngr,"%d\n",tang+1);
    fprintf(rgr_aux,"toptan= %d\n",tang);
    fprintf(rgr_aux,"topvan= %d\n",evan);
    fprintf(throu,"\n",ntr);
    for(st = 0; st < ntr; st++)
     fprintf(throu,"%s\n",TRANS_NAME(st));
   }/* Construction of Markov Chain */
  if(output_flag)
   {/* Scrittura abilitata */
    write_final_results(srg);
   }/* Scrittura abilitata */
  write_final_results(stdout);
 if(dead > 0)
  {
   fprintf(stdout,"Reachability graph contains dead markings !!\n");
   exit(1);
  }
 }/* End build_graph */
#endif
