#include <stdio.h>
#include "../../../INCLUDE/ctmc.h"
#include "../../../INCLUDE/const.h"
#include "../../../INCLUDE/struct.h"
#include "../../../INCLUDE/var_ext.h"
#include "../../../INCLUDE/macros.h"

/************** macros ************/

extern char* strtok();
extern Trans_p tabt;

/***************** Variables *******************/
 elem_set* elem_set_index=NULL;
 list_nodo* sym_rep=NULL;
 list_nodo* events=NULL;
/**********************************************/


void q_out(int NB_ESMs)
{
  int i,j;
  for(i=1;i< NB_ESMs+1;i++)
    {
      list_nodo ptr=elem_set_index[i]->p_nodo;
      printf("\n ******** ESM : %d , nodes number : %d   ******* \n", i,elem_set_index[i]->count );
      
      while(ptr)
	{
	  printf("id : %d , type :%d , arcs number  : %d \n",ptr->id,ptr->type,ptr->count );         
	  
	  l_p_nodo arcs= ptr->prim ;
	  printf(" \n $$$$$$$$ arcs entrants $$$$$$$ \n" );
	  while(arcs)
	    {
	      printf("id_trans : %d ",arcs->id_trans );
	      printf("color : ");
	      for(j=0;j<tabt[arcs->id_trans].comp_num;j++)
		printf("(%d,%d) ",arcs->col[0][j],arcs->col[1][j] );
	      printf(" parent node : %d ,type : %d \n  ",arcs->nodo->id,arcs->nodo->type); 
	      arcs=arcs->next;
	    }
	  arcs= ptr->yEx ;
	  printf("\n $$$$$$$$$ arcs sortants inst $$$$$$$$ \n" );
	  while(arcs)
	    {
	      printf("id_trans : %d ",arcs->id_trans );
	      printf("color : ");
	      for(j=0;j<tabt[arcs->id_trans].comp_num;j++)
		printf("(%d,%d) ",arcs->col[0][j],arcs->col[1][j] );
	      printf(" reached node : %d ,type : %d  \n ",arcs->nodo->id,arcs->nodo->type); 
	      arcs=arcs->next;
	    }
	  arcs= ptr->generic ;
	  printf("\n $$$$$$$$$ arcs sortants gen $$$$$$$$$$ \n" );
	  while(arcs)
	    {
	      printf("id_trans : %d ",arcs->id_trans );
	      printf("color : ");
	      for(j=0;j<tabt[arcs->id_trans].comp_num;j++)
		printf("(%d,%d)",arcs->col[0][j],arcs->col[1][j] );
	      printf(" reached node : %d ,type : %d \n  ",arcs->nodo->id,arcs->nodo->type); 
	      arcs=arcs->next;
	    } 
	  ptr=ptr->next;
	}
      getchar();
    }
}

			       
elem_set create_queue_elem()
  {
    elem_set elem=(elem_set)malloc(sizeof(struct NODE_SET));
    elem->count=0;
    elem->p_nodo=NULL;
    elem->next=elem->prev=NULL;
    return elem;
  };
 
list_nodo create_list_elem()
  {
    list_nodo elem=(list_nodo)malloc(sizeof(struct L_NODO ));
    elem->prim=elem->yEx=elem->generic=NULL;
    elem->part_q=NULL;
    elem->count= elem->weight=0;
    elem->id=elem->type=Unk;
    elem->next=NULL;
    return elem;
  };

l_p_nodo create_arc_elem()
   {
      l_p_nodo elem= (l_p_nodo)malloc(sizeof(struct L_P_NODO ));
      elem->weight=0;
      elem->id_trans=Unk;
      elem->col=NULL;
      elem->nodo=NULL;
      elem->next=NULL;
   }

void parse_binding(char* string,  int* id_trans ,int* re_sr_id ,int* re_ev_id , int*** col  )
{ 
  
  char* tok;
  char* delim=" ";
  int i;
  
  tok=strtok(string , delim);
  sscanf(tok,"%d",id_trans);

  int comp_num = tabt[(*id_trans)].comp_num;

  if(comp_num)
    {
      (*col)=(int**)calloc(2,sizeof(int*));
      (*col)[0]=(int*) calloc(comp_num,sizeof(int));
      (*col)[1]=(int*) calloc(comp_num,sizeof(int));

      for(i=0;i<comp_num;i++)
	{
	  tok=strtok(NULL,delim);
          sscanf(tok,"%d",&(*col)[0][i]);
	  tok=strtok(NULL,delim);
          sscanf(tok,"%d",&(*col)[1][i]);
	}
    }
   
  tok=strtok(NULL,delim);
  sscanf(tok,"%d",re_sr_id);
  tok=strtok(NULL,delim);
  sscanf(tok,"%d",re_ev_id);

}
 
elem_set add_sym(int re_sr_id)
{
  elem_set qu_el=NULL;
	  
  if(!elem_set_index[re_sr_id])
    qu_el=elem_set_index[re_sr_id]=create_queue_elem(); 
  else
    qu_el=elem_set_index[re_sr_id];

  qu_el->count++;	  
  list_nodo old_node=qu_el->p_nodo;
  qu_el->p_nodo=sym_rep[re_sr_id]=create_list_elem();
  sym_rep[re_sr_id]->id= re_sr_id;
  sym_rep[re_sr_id]->next=old_node;
 
  return qu_el;
}

elem_set add_event( int re_sr_id,int re_ev_id )
{
  elem_set qu_el=NULL;
	      
  if(!elem_set_index[re_sr_id])
    qu_el=elem_set_index[re_sr_id]=create_queue_elem();  
  else
    qu_el=elem_set_index[re_sr_id];
  
  qu_el->count++;
  list_nodo old_node=NULL;
  list_nodo* new_node=NULL;

  if(sym_rep[re_sr_id])
    {
      old_node=sym_rep[re_sr_id]->next;
      new_node=& (sym_rep[re_sr_id]->next);
    }
  else
    {
      old_node=qu_el->p_nodo;
      new_node=& (qu_el->p_nodo);
    }

  (*new_node) =events[re_ev_id]=create_list_elem();
  events[re_ev_id]->id=re_ev_id;
  events[re_ev_id]->type=INSTANCE;
  events[re_ev_id]->next=old_node;

  return qu_el;
}

void join_sr_to_sr( int source , int reached, l_p_nodo arc, l_p_nodo rev_arc) 
{
  arc->nodo=sym_rep[reached];
  rev_arc->nodo=sym_rep[source]; 
  arc->next=sym_rep[source]->yEx;
  sym_rep[source]->yEx=arc;
  rev_arc->next=sym_rep[reached]->prim;
  sym_rep[reached]->prim=rev_arc; 
}

void join_ev_to_ev( int source , int reached, l_p_nodo arc, l_p_nodo rev_arc) 
{
  arc->nodo=events[reached];
  rev_arc->nodo=events[source]; 

  arc->next=events[source]->yEx;
  events[source]->yEx=arc;

  rev_arc->next=events[reached]->prim;
  events[reached]->prim=rev_arc;
}
void join_ev_to_sr(int source , int reached, l_p_nodo arc, l_p_nodo rev_arc)
{
  arc->nodo=sym_rep[reached];
  rev_arc->nodo=events[source]; 
  arc->next=events[source]->yEx;
  events[source]->yEx=arc;
  rev_arc->next=sym_rep[reached]->prim;
  sym_rep[reached]->prim=rev_arc; 
} 

void add_arcs( int id_trans , int** col, int source, int  re_sr_id ,int  re_ev_id,  l_p_nodo arc, l_p_nodo rev_arc,int flag  )
{
  
  arc->id_trans=rev_arc->id_trans=id_trans;
  arc->col=rev_arc->col=col;
 
  if(flag==GEN)
    {    
      if(!sym_rep[re_sr_id])
	(void) add_sym(re_sr_id );
      join_sr_to_sr( source, re_sr_id, arc, rev_arc);                    
    }

  if(flag==INST)
    {   
      if( re_ev_id != Unk)
	{
	  if( !events[re_ev_id])
	   (void )add_event(re_sr_id, re_ev_id );
	  join_ev_to_ev( source ,re_ev_id  , arc, rev_arc);  
	} 
      else
	{
	  if(!sym_rep[re_sr_id])
	    (void)add_sym(re_sr_id );	    
	  join_ev_to_sr(source ,re_sr_id, arc, rev_arc);
	}
  
    }

}



void parse_binding_and_add(FILE* f,int source, int nb_inst, int type)
{
  int id_trans , re_sr_id , re_ev_id ;
  int ** col;
  l_p_nodo arc, rev_arc;
  char string[MAXSTRING];
  int i;

  for(i=0;i<nb_inst;i++)
    {
      
      fgets( string, MAXSTRING - 1, f );
      parse_binding ( string ,&id_trans , &re_sr_id , &re_ev_id, &col );
      arc=create_arc_elem();
      rev_arc=create_arc_elem();
      add_arcs( id_trans ,col,source, re_sr_id , re_ev_id, arc, rev_arc,type );
      
    }

} 

void treat_special_cases( list_nodo sr )
{
  list_nodo event=sr->next;
  if(sr->yEx)
    while(event)
      {
	event->generic=sr->yEx;
	event->count +=sr->count;
        event=event->next;
      }
    
}        

void OutPutParser(char* net_name)
{
  int sr_id ,sat ,gen_inst , even_id, inst, nb_event,i,real_number ;
  char  tmp[MAXSTRING ],net[MAXSTRING];
  int NB_ESMs ;
  int NB_EVENTS ; 
 
  compose_name(net,net_name,"esrg");
  FILE* f=fopen(net,"r"); 

  compose_name(net,net_name,"stat");
  FILE* stat= fopen(net,"r");  
  fscanf(stat,"%d %d",&NB_ESMs,&NB_EVENTS );
  fclose(stat);

  elem_set_index = (elem_set*)calloc(NB_ESMs+1,sizeof( elem_set));
  sym_rep        = (list_nodo*)calloc (NB_ESMs+1,sizeof(list_nodo));
  events         = (list_nodo*)calloc (NB_EVENTS+1,sizeof(list_nodo));

  while(  fgets(tmp, MAXSTRING - 1, f ) )
    {
      sscanf(tmp,"%d %d %d %d",&sr_id,&sat,&gen_inst,&nb_event );

      if( sat == SR_SAT  )
	{
	  if(!sym_rep[sr_id]) 
	    (void)add_sym(sr_id);
      	  
	  sym_rep[sr_id]->count=gen_inst;

	  if( (nb_event && sym_rep[sr_id]->type != MACROP)|| 
	       sym_rep[sr_id] 
            )
	    sym_rep[sr_id]->type= MACROP;
	  else 
	    sym_rep[sr_id]->type= MACROC; 

	  parse_binding_and_add( f,sr_id,gen_inst, GEN );
	  treat_special_cases(sym_rep[sr_id]);     
	}
 
      for(i=0;i<nb_event;i++)
	{
	  fgets(tmp, MAXSTRING - 1, f );
	  sscanf(tmp,"%d %d ",&even_id,&inst);

	  if(!events[even_id])
	    (void)add_event(sr_id, even_id);		
	     
	  events[even_id]->count=inst;

	  if(sym_rep[sr_id])
	    {
	      events[even_id]->generic=sym_rep[sr_id]->yEx;
	      events[even_id]->count +=sym_rep[sr_id]->count;
	    }
	  parse_binding_and_add( f,even_id,inst, INST );
	 
	}      
    }

  for(i=1;i< NB_ESMs+1;i++)
    {
      if(i < NB_ESMs+1 -1)
	elem_set_index[i]->next = elem_set_index[i+1];
      if(i > 1)
	elem_set_index[i]->prev = elem_set_index[i-1];
    }
  free( sym_rep );      
  free(events);
  free(	elem_set_index);
  
}


int main(int  argc,  char  *argv[])
{

 initialize (2, argv);

 OutPutParser( argv[1]);

 
}
