%{

/* .......... Declarations C ........*/
#pragma warning (disable:4786)
#include "../../../INCLUDE/const.h"
#include "../../../INCLUDE/struct.h"
#include "../../../INCLUDE/var_ext.h"
#include "../../../INCLUDE/macros.h"
#include "../../../INCLUDE/ctmc.h"

/************** macros ************/

/***************** Variables *******************/

  
  char*   Ptr_Cur=NULL;
  int     Lim_Pos=0;
 elem_set* elem_set_index=NULL;
 list_nodo* sym_rep=NULL;
 list_nodo* events=NULL;
 l_p_nodo* gen_arcs=NULL;
 int** col=NULL;
 int flag=Unk;
 int SOURCE, EVENT;
 int nb_var;
/**********************************************/

/**************** flex functions ************************/
extern int yylex();
extern FILE *yyin;
void yyerror(char *s){  printf("parsing error: %s\n", s); } 
int outwrap(){ return (1); }
extern void   flush_buffer();
/*******************************************************/
			       
elem_set create_queue_elem()
  {
    elem_set elem=malloc(sizeof(struct NODE_SET));
    elem->count=0;
    elem->p_nodo=NULL;
    elem->next=elem->prev=NULL;
    return elem;
  };
 
list_nodo create_list_elem()
  {
    list_nodo elem=malloc(sizeof(struct L_NODO ));
    elem->prim=elem->yEx=elem->generic=NULL;
    elem->part_q=NULL;
    elem->count= elem->weight=0;
    elem->id=elem->type=Unk;
    elem->next=NULL;
    return elem;
  };

l_p_nodo create_arc_elem()
   {
      l_p_nodo elem=malloc(sizeof(struct L_P_NODO ));
      elem->weight=0;
      elem->id_trans=Unk;
      elem->col=NULL;
      elem->nodo=NULL;
      elem->next=NULL;
   }


 
/************** extern functions needed to compute local partitions *******/
/************************************************************************/

 
          
%}

/*........... Declarations Yacc .....*/

%union { 	

  int j;

}
/*-----------------------------------------les tokens----------------------------------*/
%token ESM EV FIR
%token <j> IDENT 
%type <j>  ESM_HEAD EVENT_HEAD

%left IDENT 


/*----------------------------------------le debut du parse-----------------------------------*/
%start BLOCKS


%%

BLOCKS      : BLOCK  BLOCKS | BLOCK  ;

BLOCK       :  SR_BLOCK {  printf("sr_block with events");getchar(); } EVENT_BLOCK | SR_BLOCK  {  printf("sr_block without events");getchar(); } ; 
      
SR_BLOCK    :  ESM_HEAD {flag=GEN; SOURCE=$1; printf("esm_head with instances");getchar(); } INST |  ESM_HEAD {flag=GEN; SOURCE=$1;  printf("esm_head without instances");getchar(); } ;

     
ESM_HEAD    : ESM  IDENT  IDENT  IDENT  IDENT 
              {
		int sr_id=$2,sat=$3,gen_inst=$4,nb_event=$5;
		elem_set qu_el=NULL;

               	if( sat == SATURED_SYM && (!nb_event || gen_inst ) )
		  {
		    
		    if(!sym_rep[sr_id])
		      {
			if(!elem_set_index[sr_id])
			  qu_el=create_queue_elem();
			else
			  qu_el=elem_set_index[sr_id];

                        list_nodo old_node=qu_el->p_nodo;
			qu_el->p_nodo=sym_rep[sr_id]=create_list_elem();
			qu_el->p_nodo->next=old_node;
		      }
		    else
		      qu_el=elem_set_index[sr_id];

		    qu_el->count++;
		    qu_el->p_nodo->id=sr_id;
		    qu_el->p_nodo->count=gen_inst;
		   
		    if(nb_event)
		      qu_el->p_nodo->type= MACROP;
		    else 
		      qu_el->p_nodo->type= MACROC; 
		    
		    
		  }
	        $$ = sr_id ;
		
	      } ;                   
         
INST        : FIR  IDENT 
                     {
		       col=NULL;
		       if(tabt[$2].comp_num)
			 {
			   nb_var=0; 
			   col=(int**)calloc(2,sizeof(int*));
			   col[0]=calloc(tabt[$2].comp_num,sizeof(int));
			   col[1]=calloc(tabt[$2].comp_num,sizeof(int));
			 }
		     }
             BINDING  IDENT  IDENT
              {
                int id_trans=$2, re_sr_id =$5, re_ev_id=$6;
		l_p_nodo arc=create_arc_elem();
		l_p_nodo rev_arc=create_arc_elem();

                if(flag==GEN)
		  {
		    arc->id_trans=rev_arc->id_trans=id_trans;
		    arc->col=rev_arc->col=col;
		                  
		    if(!sym_rep[re_sr_id])
		      {
			elem_set qu_el=NULL;

		       	if(!elem_set_index[re_sr_id])
			  qu_el=create_queue_elem();
			else
			  qu_el=elem_set_index[re_sr_id];

			list_nodo old_node=qu_el->p_nodo;
			qu_el->p_nodo=sym_rep[re_sr_id]=create_list_elem();
			qu_el->p_nodo->next=old_node;

		      }
                    
		    arc->nodo=sym_rep[re_sr_id];
		    rev_arc->nodo=sym_rep[SOURCE]; 
		    arc->next=sym_rep[SOURCE]->yEx;
		    sym_rep[SOURCE]->yEx=arc;
		    rev_arc->next=sym_rep[re_sr_id]->prim;
		    sym_rep[re_sr_id]->prim=rev_arc; 
		   		    
		  }
		else
		  {
		    arc->id_trans=rev_arc->id_trans=id_trans;
		    arc->col=rev_arc->col=col;
		    if(re_ev_id != Unk)
		      {
			if(!events[re_ev_id])
			  {
			    
			    elem_set qu_el=NULL;
			    
			    if(!elem_set_index[re_sr_id])
			      qu_el=create_queue_elem();
			    else
			      qu_el=elem_set_index[re_sr_id];
			  
			    list_nodo old_node=NULL;
			  
			    if(sym_rep[re_sr_id])
			      old_node=qu_el->p_nodo->next;
			    else
			      old_node=qu_el->p_nodo;
			    
			    qu_el->p_nodo =events[re_ev_id]=create_list_elem();
			    qu_el->p_nodo->next=old_node;
			  }
                   
			arc->nodo=events[re_ev_id];
			rev_arc->nodo=events[EVENT]; 
			arc->next=events[EVENT]->yEx;
			events[EVENT]->yEx=arc;
			rev_arc->next=events[re_ev_id]->prim;
			events[re_ev_id]->prim=rev_arc; 
		      }
		    else
		      {
			arc->id_trans=rev_arc->id_trans=id_trans;
			arc->col=rev_arc->col=col;
			if(!sym_rep[re_sr_id])
			  {
			    elem_set qu_el=NULL;

			    if(!elem_set_index[re_sr_id])
			      qu_el=create_queue_elem();
			    else
			      qu_el=elem_set_index[re_sr_id];
			    
			    list_nodo old_node=qu_el->p_nodo;
			    qu_el->p_nodo=sym_rep[re_sr_id]=create_list_elem();
			    qu_el->p_nodo->next=old_node;
			
			  }
                    
			arc->nodo=sym_rep[re_sr_id];
			rev_arc->nodo=events[EVENT]; 
			arc->next=events[EVENT]->yEx;
			events[EVENT]->yEx=arc;
			rev_arc->next=sym_rep[re_sr_id]->prim;
			sym_rep[re_sr_id]->prim=rev_arc; 
		      }
		  
		  }
              }  INST ;

BINDING     : IDENT ':' IDENT 
              {
		col[0][nb_var]=$1;
		col[1][nb_var]=$3;
		nb_var++;
              }
              BINDING  |   ;

EVENT_BLOCK : EVENT_HEAD {flag=INST;EVENT=$1; }  INST |  EVENT_HEAD {flag=INST;EVENT=$1; } ;
          
EVENT_HEAD  : EV  IDENT  IDENT 
              {
		int ev_id=$2,inst=$3 ; 
		elem_set qu_el=NULL;
	                  
		if(!events[ev_id])
		  {
			
		    elem_set qu_el=NULL;

		    if(!elem_set_index[SOURCE])
		      qu_el=create_queue_elem();
		    else
		      qu_el=elem_set_index[SOURCE];

		    list_nodo old_node=NULL;

		    if(sym_rep[SOURCE])
		      old_node=qu_el->p_nodo->next;
		    else
		      old_node=qu_el->p_nodo;
			
		    qu_el->p_nodo =events[ev_id]=create_list_elem();
		    qu_el->p_nodo->next=old_node;
			
		  }
                if(sym_rep[SOURCE])
		  events[EVENT]->generic=sym_rep[SOURCE]->yEx;

		$$=ev_id;      
    
	      };


%%
 
elem_set ctmc_parser (FILE* f,int NB_ESMs,int NB_EVENTS)
{

  char c;
  int i=0;
  char* ptr; 
  elem_set  Q=NULL;

  elem_set_index = calloc(NB_ESMs,sizeof(Tree_p));
  gen_arcs       = calloc(NB_ESMs,sizeof(l_p_nodo));
  sym_rep        = calloc (NB_ESMs,sizeof(list_nodo));
  events         = calloc (NB_EVENTS,sizeof(list_nodo));


  ptr=Ptr_Cur=(char*)malloc(STR_SIZE*sizeof(char));
     
  while((c=fgetc(f))!=EOF)  
    {
      Ptr_Cur[i]=c; 
      i++;
    }

  Ptr_Cur[i]='\0';
  Lim_Pos=(int)Ptr_Cur+strlen(Ptr_Cur);   
   
  i=yyparse();
  Q=elem_set_index[0];
  for(i=0;i<NB_ESMs;i++)
    {
      if(i+1 < NB_ESMs)
	elem_set_index[i]->next= elem_set_index[i+1];
      if(i-1>=0)
	elem_set_index[i]->prev= elem_set_index[i-1];	     
    }
  
  free(ptr);
  free(sym_rep);
  free(events);
  free(	elem_set_index);
  return Q;
}


int main(int  argc,  char  *argv[])
{
  /*initialize (2, argv);
  FILE * f = fopen("/data/baarir/TEST_DIR/nets/Jele.esrg","r");
  ctmc_parser (f,8,9);
  */
  int val;
  char val1;
  char str[10];
  str[0]='1';
  str[1]='0';

  str[5]='5';
  str[6]='\n';
  sscanf(str,"%d %d",&val,&val1);
  printf("%d \n",val);
  printf("%d \n",val1);
}
