%{

/* .......... Declarations C ........*/
#pragma warning (disable:4786)
#include "../../../INCLUDE/const.h"
#include "../../../INCLUDE/struct.h"
#include "../../../INCLUDE/var_ext.h"
#include "../../../INCLUDE/macros.h"
#include "../../../INCLUDE/ctmc.h"

/************** macros ************/

/***************** Variables *******************/

  
  char*   Ptr_Cur=NULL;
  int     Lim_Pos=0;
 elem_set* elem_set_index=NULL;
 list_nodo* sym_rep=NULL;
 list_nodo* events=NULL;
 l_p_nodo* gen_arcs=NULL;
 int** col=NULL;
 int flag=Unk;
 int SOURCE, EVENT;
 int nb_var=0;
 int* numbers=NULL; 
/**********************************************/

/**************** flex functions ************************/
extern int yylex();
extern FILE *yyin;
void yyerror(char *s){  printf("parsing error: %s\n", s); } 
int outwrap(){ return (1); }
extern void   flush_buffer();
/*******************************************************/
			       
elem_set create_queue_elem()
  {
    elem_set elem=malloc(sizeof(struct NODE_SET));
    elem->count=0;
    elem->p_nodo=NULL;
    elem->next=elem->prev=NULL;
    return elem;
  };
 
list_nodo create_list_elem()
  {
    list_nodo elem=malloc(sizeof(struct L_NODO ));
    elem->prim=elem->yEx=elem->generic=NULL;
    elem->part_q=NULL;
    elem->count= elem->weight=0;
    elem->id=elem->type=Unk;
    elem->next=NULL;
    return elem;
  };

l_p_nodo create_arc_elem()
   {
      l_p_nodo elem=malloc(sizeof(struct L_P_NODO ));
      elem->weight=0;
      elem->id_trans=Unk;
      elem->col=NULL;
      elem->nodo=NULL;
      elem->next=NULL;
   }


 
/************** extern functions needed to compute local partitions *******/
/************************************************************************/

 
          
%}

/*........... Declarations Yacc .....*/

%union { 	

  int j;

}
/*-----------------------------------------les tokens----------------------------------*/
%token <j> IDENT 


%left IDENT 


/*----------------------------------------le debut du parse-----------------------------------*/
%start NUMBERS


%%

NUMBERS        :  IDENT { numbers = realloc(numbers,nb_var* sizeof(int));  numbers [ nb_var]=$1; nb_var++} NUMBERS |  ; 
                   
%%
 
void binding_parse  ( char* string )
{

  char* ptr; 
  ptr=Ptr_Cur=string ;  
  Lim_Pos=(int)Ptr_Cur+strlen(Ptr_Cur);   
  i=yyparse();
}

void OutPutParser( FILE* f,int NB_ESMs,int NB_EVENTS)
{
  int sr_id ,sat ,gen_inst ,nb_event ;
  char* string;
  while(1)
    {
      fscanf(f,"%d %d %d %d %d",&sr_id,&sat,&gen_inst,&nb_event);
      elem_set qu_el=NULL;

      if( sat == SATURED_SYM && (!nb_event || gen_inst ) )
	{
		    
	  if(!sym_rep[sr_id])
	    {
	      if(!elem_set_index[sr_id])
		qu_el=create_queue_elem();
	      else
		qu_el=elem_set_index[sr_id];

	      list_nodo old_node=qu_el->p_nodo;
	      qu_el->p_nodo=sym_rep[sr_id]=create_list_elem();
	      qu_el->p_nodo->next=old_node;
	    }
	  else
	    qu_el=elem_set_index[sr_id];

	  qu_el->count++;
	  qu_el->p_nodo->id=sr_id;
	  qu_el->p_nodo->count=gen_inst;
	  
	  if(nb_event)
	    qu_el->p_nodo->type= MACROP;
	  else 
	    qu_el->p_nodo->type= MACROC; 
		    
		    
	}
      for(i=0;i<gen_inst;i++)
	{
	  fgets( string, MAXSTRING - 1, fp );
	}
    }



}

int main(int  argc,  char  *argv[])
{

  char* str=calloc(10,sizeof(char));
  int i;
  str[0]='1';
  str[1]='2';
  str[2]=' ';
  str[3]='3';
  str[4]=' ';
  str[5]='4';
 
   binding_parse  ( str );
  
  for(i=0;i<nb_var;i++)
    printf("%d \n", numbers[i]);
  int nb1,nb2,nb3;
  sscanf(str,"%d %d %d ",&nb1,&nb2,&nb3);
  printf("%d %d %d  ",  nb1,nb2,nb3);
}
