#define ___SWN___
#	include "global.h"
#	include "res.h"
#	include <Mrm/MrmPublic.h>  
#include "swn.h"

static int whichClevel;
static int whichType;
static Widget sim_dialog,sim_InitWasteText,sim_MidWasteText,sim_MinBatchText, sim_MaxBatchText, sim_ApproxText, sim_SeedText,sim_VerboseShow;
static Widget rg_dialog,rg_Verbose;
extern  ScheduleSwn(int,int,int,int,int,int,int,int,int);

void ShowSwnRGOptionsDialog(int t)
{
	Arg args[1];
	XmString xms;
	
	whichType = t;
	if(t)
		xms=XmStringCreateSimple("SWN Ordinary RG Options");
	else
		xms=XmStringCreateSimple("SWN Symbolic RG Options");
		
	XtSetArg(args[0],XmNdialogTitle,xms);
	XtSetValues(rg_dialog,args,1);
	XmStringFree(xms);
	XtManageChild(rg_dialog);
}

void HideSwnRGOptionsDialog(void)
{
	XtUnmanageChild(rg_dialog);
}

static void OkSwnRGDialogCB(Widget w, XtPointer closure, XtPointer call_data)
{
	Boolean verboseOn;
	int p;
	
	verboseOn = XmToggleButtonGadgetGetState(rg_Verbose);
	p=(whichType << 1 ) + 1;
	ScheduleSwn(p,verboseOn,0,0,0,0,0,0,0);
	HideSwnRGOptionsDialog();	
}
	
static void CancelSwnRGDialogCB(Widget w, XtPointer closure, XtPointer call_data)
{
	ResetConsoleDialog();
	HideSwnRGOptionsDialog();
}
	
void RegisterSwnRGOptionsDialog(void)
{
		static MrmRegisterArg	regvec[] = 
		{
			{"OkSwnRGDialogCB"	,(XtPointer)OkSwnRGDialogCB},
			{"CancelSwnRGDialogCB"	,(XtPointer)CancelSwnRGDialogCB}
		};
		
	static MrmCount		regnum = sizeof(regvec)/sizeof(MrmRegisterArg);
	
  	if (MrmRegisterNames (regvec, regnum) != MrmSUCCESS)
		XtError("Sorry : can't register RegisterSwnRGOptionsDialog names\n");
}

void InitSwnRGOptionsDialog(void)
{
	rg_dialog = XtNameToWidget(frame_w, "*SwnRGDialog");
	rg_Verbose = XtNameToWidget(rg_dialog, "*SwnRGDialog_VerboseShow");	
}
	
	
	
void ShowSwnSimOptionsDialog(int t)
{
	Arg args[1];
	XmString xms;
	
	whichType = t;
	if(t)
		xms=XmStringCreateSimple("SWN Ordinary Simulation Options");
	else
		xms=XmStringCreateSimple("SWN Symbolic Simulation Options");
		
	XtSetArg(args[0],XmNdialogTitle,xms);
	XtSetValues(sim_dialog,args,1);
	XmStringFree(xms);	
	XtManageChild(sim_dialog);
}

void HideSwnSimOptionsDialog(void)
{
	XtUnmanageChild(sim_dialog);
}



static void OkSimOptionsDialogCB(Widget w, XtPointer closure, XtPointer call_data)
{
	char * tmp;
	char * errmess=NULL;
	Widget focusTo;
	int initWaste,midWaste,minBatch,maxBatch,approx,seed,confLevel,verbose;
	static int cvtClevel[]={60,70,80,90,95,99};
	
	
	tmp= XmTextFieldGetString(sim_InitWasteText);
	if((initWaste=atoi(tmp)) >= 0)
	{
		XtFree(tmp);
		tmp=XmTextFieldGetString(sim_MidWasteText);
		if((midWaste=atoi(tmp)) > 0)
		{
			XtFree(tmp);
			tmp=XmTextFieldGetString(sim_MinBatchText);
			if((minBatch=atoi(tmp)) > 0)
			{
				XtFree(tmp);
				tmp=XmTextFieldGetString(sim_MaxBatchText);
				if((maxBatch=atoi(tmp)) > 0)
				{
					XtFree(tmp);
					if(minBatch <= maxBatch)
					{
						tmp=XmTextFieldGetString(sim_ApproxText);
						if((approx=atoi(tmp)) > 0)
						{
							XtFree(tmp);
							tmp=XmTextFieldGetString(sim_SeedText);
							if((seed=atoi(tmp)) <= 0)
							{
								errmess="Incorrect Seed Value [ > 0]";
								focusTo = sim_SeedText;
							}
							else
							{
								char paramStr[500];
								
								confLevel = cvtClevel[whichClevel];
								verbose = XmToggleButtonGadgetGetState(sim_VerboseShow);
								
								/*sprintf(paramStr,"swn_sym_sim -f %d -t %d -m %d -M %d -c %d -a %d -s %d %s",
										initWaste,midWaste,minBatch,maxBatch,confLevel,approx,seed,verbose);
								puts(paramStr);
								*/

								ScheduleSwn(whichType << 1,initWaste,midWaste,minBatch,maxBatch,confLevel,approx,seed,verbose);
							}
						}
						else
						{
							errmess="Incorrect Accuracy Value [ > 0]";
							focusTo = sim_ApproxText;
						}		
					}
					else
					{
						errmess="Wrong Minimum or Maximum Batch Length [ Min <= Max]";
						focusTo = sim_MaxBatchText;
					}		
					
				}
				else
				{
					errmess="Incorrect Maximum Batch Length [ > 0]";
					focusTo = sim_MaxBatchText;
				}		
			}
			else
			{
				errmess="Incorrect Minimum Batch Length [ > 0]";
				focusTo = sim_MinBatchText;
			}		
		}
		else
		{
			errmess="Incorrect Batch Spacing Value [ > 0]";
			focusTo = sim_MidWasteText;
		}		
	}
	else
	{
		errmess="Incorrect Initial Transitory Value [ >= 0]";
		focusTo = sim_InitWasteText;
	}
	XtFree(tmp);
	if(errmess != NULL)
	{
		int insertlen;
		
		ShowErrorDialog(errmess,sim_dialog);
		tmp=XmTextFieldGetString(focusTo); 
		insertlen=strlen(tmp);
		XmProcessTraversal(focusTo,XmTRAVERSE_CURRENT);
		XmTextFieldSetSelection(focusTo,0,insertlen,XtLastTimestampProcessed(XtDisplay(focusTo)));
		XmTextFieldSetHighlight(focusTo,0,insertlen,XmHIGHLIGHT_SELECTED);
		XtFree(tmp);
	}
	else
		HideSwnSimOptionsDialog();
}

static void CancelSimOptionsDialogCB(Widget w, XtPointer closure, XtPointer call_data)
{
	ResetConsoleDialog();
	HideSwnSimOptionsDialog();
}

static void SwnSimOptionsCB(Widget w, int closure, XtPointer call_data)
{
	whichClevel=closure;
}

void RegisterSwnSimOptionsDialog(void)
{
	static MrmRegisterArg	regvec[] = 
	{
		{"SWN_CLEVEL_60"	,(XtPointer)SWN_CLEVEL_60},
		{"SWN_CLEVEL_70"	,(XtPointer)SWN_CLEVEL_70},
		{"SWN_CLEVEL_80"	,(XtPointer)SWN_CLEVEL_80},
		{"SWN_CLEVEL_90"	,(XtPointer)SWN_CLEVEL_90},
		{"SWN_CLEVEL_95"	,(XtPointer)SWN_CLEVEL_95},
		{"SWN_CLEVEL_99"	,(XtPointer)SWN_CLEVEL_99},
		{"SwnSimOptionsCB"	,(XtPointer)SwnSimOptionsCB},
		{"CancelSimOptionsDialogCB"	,(XtPointer)CancelSimOptionsDialogCB},
		{"OkSimOptionsDialogCB"	,(XtPointer)OkSimOptionsDialogCB}
	};
	
	static MrmCount		regnum = sizeof(regvec)/sizeof(MrmRegisterArg);
	
	if (MrmRegisterNames (regvec, regnum) != MrmSUCCESS)
		XtError("Sorry : can't register RegisterSwnSimOptionsDialog names\n");	
}


void InitSwnSimOptionsDialog(void)
{
	sim_dialog = XtNameToWidget(frame_w, "*SimOptionsDialog");
	sim_InitWasteText = XtNameToWidget(sim_dialog, "*SimOptionsDialog_InitWasteText");	
	sim_MidWasteText = XtNameToWidget(sim_dialog, "*SimOptionsDialog_MidWasteText");	
	sim_MinBatchText = XtNameToWidget(sim_dialog, "*SimOptionsDialog_MinBatchText");	
	sim_MaxBatchText = XtNameToWidget(sim_dialog, "*SimOptionsDialog_MaxBatchText");	
	sim_ApproxText = XtNameToWidget(sim_dialog, "*SimOptionsDialog_ApproxText");	
	sim_SeedText = XtNameToWidget(sim_dialog, "*SimOptionsDialog_SeedText");	
	sim_VerboseShow = XtNameToWidget(sim_dialog, "*SimOptionsDialog_VerboseShow");	
	
	XmTextFieldSetString(sim_InitWasteText,"1000");
	XmTextFieldSetString(sim_MidWasteText,"1000");
	XmTextFieldSetString(sim_MinBatchText,"1000");
	XmTextFieldSetString(sim_MaxBatchText,"2000");
	XmTextFieldSetString(sim_ApproxText,"15");
	XmTextFieldSetString(sim_SeedText,"31415");
	whichClevel = SWN_CLEVEL_60;
}

